// CENTERDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CENTER.h"
#include "CENTERDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef struct {
   int origX;
   int origY;
   int newX;
   int newY;
}SIZE_INFO;

#define MOVE_NONE       -1
#define MOVE_CENTER      0
#define MOVE_RIGHT       1
#define MOVE_BOTTOM      2
#define MOVE_CENTER_HORZ 4
#define MOVE_CENTER_VERT 8

/////////////////////////////////////////////////////////////////////////////
// CCENTERDlg dialog

CCENTERDlg::CCENTERDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCENTERDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCENTERDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCENTERDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCENTERDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCENTERDlg, CDialog)
	//{{AFX_MSG_MAP(CCENTERDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCENTERDlg message handlers

BOOL CCENTERDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
   // set desired positions 
   ::SetWindowLong(::GetDlgItem(m_hWnd, IDC_BUTTON1), GWL_USERDATA, MOVE_NONE);
   ::SetWindowLong(::GetDlgItem(m_hWnd, IDC_BUTTON2), GWL_USERDATA, MOVE_RIGHT);
   ::SetWindowLong(::GetDlgItem(m_hWnd, IDC_BUTTON3), GWL_USERDATA, MOVE_BOTTOM);
   ::SetWindowLong(::GetDlgItem(m_hWnd, IDC_BUTTON4), GWL_USERDATA, MOVE_BOTTOM | MOVE_RIGHT);
   ::SetWindowLong(::GetDlgItem(m_hWnd, IDC_BUTTON5), GWL_USERDATA, MOVE_CENTER_HORZ | MOVE_BOTTOM);
   ::SetWindowLong(::GetDlgItem(m_hWnd, IDC_BUTTON6), GWL_USERDATA, MOVE_CENTER_VERT | MOVE_RIGHT);
     
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCENTERDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CCENTERDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CALLBACK MoveChildrenProc(HWND hwnd, SIZE_INFO *s) 
{
   LONG posit = ::GetWindowLong(hwnd, GWL_USERDATA);
   if (posit != MOVE_NONE) {
	   RECT rt;
      ::GetWindowRect(hwnd, &rt);
      HWND hWndParent = ::GetParent(hwnd);
      if (hWndParent) {
         POINT pt = {rt.left, rt.top};   
         ::ScreenToClient(hWndParent, &pt);
         if (posit == MOVE_CENTER) {
            pt.x += ((s->newX - s->origX) / 2);
	         pt.y += ((s->newY - s->origY) / 2);
         }
         else {
            // check right bit
            if ((posit & MOVE_RIGHT) != 0) pt.x += (s->newX - s->origX);
            // check bottom bit
            if ((posit & MOVE_BOTTOM) != 0) pt.y += (s->newY - s->origY);
            // check center horizontal bit
            if ((posit & MOVE_CENTER_HORZ) != 0) pt.x += ((s->newX - s->origX) / 2);
            // check center vertical bit
            if ((posit & MOVE_CENTER_VERT) != 0) pt.y += ((s->newY - s->origY) / 2);
         }
	      ::MoveWindow(hwnd, pt.x, pt.y, rt.right - rt.left, rt.bottom - rt.top, TRUE);
      }
   }
   return TRUE;
};

void CCENTERDlg::OnSize(UINT nType, int cx, int cy) 
{	
	static int x = 0, y = 0;
   CDialog::OnSize(nType, cx, cy);
   if (!IsIconic() ) {  // process only if not minimized
      if (x || y) {     // don't process if it is the first time
         SIZE_INFO sinfo = {x, y, cx, cy};
			EnumChildWindows(m_hWnd, (WNDENUMPROC)MoveChildrenProc, (LPARAM)&sinfo);
			Invalidate();
		}
		x = cx;
		y = cy;
	}
}
